
	.setcpu		"6502"

	.include	"nes.inc"
	.include	"zeropage.inc"
	.include	"..\..\include\nsd.inc"

;--------------------------------------
;L[ǂݍݗp̒`

JOY_A		= $80
JOY_B		= $40
JOY_Select	= $20
JOY_Start	= $10
JOY_Up		= $08
JOY_Down	= $04
JOY_Left	= $02
JOY_Right	= $01

;=======================================================================
;	Macros
;-----------------------------------------------------------------------

.MACPACK generic
.MACPACK longbranch 

.macro  ldax    arg
	.if (.match (.left (1, {arg}), #))
		; immediate mode
		lda     #<(.right (.tcount ({arg})-1, {arg}))
		ldx     #>(.right (.tcount ({arg})-1, {arg}))
	.else
		; assume absolute or zero page
		lda     arg
		ldx     1+(arg)
	.endif
.endmacro

.macro  addw    Arg
	clc
	.if (.match (.left (1, {arg}), #))
		; immediate mode
		adc     #<(.right (.tcount ({arg})-1, {arg}))
		adc     #>(.right (.tcount ({arg})-1, {arg}))
	.else
		; assume absolute or zero page
		adc     arg
		adc     1+(arg)
	.endif
.endmacro

.macro  subw    Arg
	sec
	.if (.match (.left (1, {arg}), #))
		; immediate mode
		sbc     #<(.right (.tcount ({arg})-1, {arg}))
		sbc     #>(.right (.tcount ({arg})-1, {arg}))
	.else
		; assume absolute or zero page
		sbc     arg
		sbc     1+(arg)
	.endif
.endmacro

.macro	shl	arg, c
	.repeat	c
		asl	arg
	.endrepeat
.endmacro

.macro	shr	arg, c
	.repeat	c
		lsr	arg
	.endrepeat
.endmacro


