
	.export		_irq_main

	.include	"vrc7ed.inc"

;===============================================================
;			irq_main(void);
;---------------------------------------------------------------
;	Summary :		IRQ Routine
;	Arguments :		None
;	Return :		None
;	Modifies :		None
;	Useage :		Please write this address to interrupt vector
;===============================================================
.code
.proc	_irq_main

	;register push
	pha
	tya
	pha
	txa
	pha

	lda	APU_CHANCTRL
	bpl	@DPCM
	php

	; to do : call the DPCM-IRQ routine

	plp
@DPCM:	bvc	@FRAME

	; to do : call the FRAME-IRQ routine

@FRAME:
	;register pop
	pla
	tax
	pla
	tay
	pla

	rti
.endproc
