
	.export		_read_key
	.export		_inkey

	.export		_now_key

	;ꎞ[NGA
	.importzp	tmp1,tmp2,tmp3,tmp4
	.importzp	ptr1,ptr2,ptr3,ptr4

	.include	"vrc7ed.inc"

	.exportzp	pad

;-----------------------------------------------------------------------------
.zeropage

;
;	mlhōpxɃANZXϐ́A[y[WɔzuB
;

pad:	.byte	0,0		;NMI荞݂ŃL[ǂŁAɊi[B

;===============================================================
;	char	__fastcall__	_read_key(char	key);
;---------------------------------------------------------------
;	Summary :		Read Key
;	Arguments :	A	PAD	0:PAD-1  /  1:PAD-2
;	Return :	A	Key Data
;			Y	PAD	0:PAD-1  /  1:PAD-2
;	Modifies :	X	
;	Useage :		
;===============================================================
.code
.proc	_read_key

	and	#$01
	tay
	lda	pad,y
	rts
.endproc

;===============================================================
;	char	__fastcall__	_read_key(char	key);
;---------------------------------------------------------------
;	Summary :		Key read with old key check
;	Arguments :	A	0:PAD-1  /  1:PAD-2
;	Return :	A	Key Data
;	Modifies :	X Y	
;	Useage :		O񂩂L[ɕωꍇ́A0Ԃ܂B
;===============================================================

.bss
_old_key:	.byte	0, 0	;ߋ̃L[
_now_key:	.byte	0, 0	;݂̃L[

.code
.proc	_inkey

	and	#$01
	tay

	lda	pad
	cmp	_old_key
	beq	@L1
	sta	_old_key
	jmp	@E1
@L1:	lda	#0
@E1:	sta	_now_key

	lda	pad + 1
	cmp	_old_key + 1
	beq	@L2
	sta	_old_key + 1
	jmp	@E2
@L2:	lda	#0
@E2:	sta	_now_key + 1

	lda	_now_key,y

	rts
.endproc
